#include "romaddr.hh"
#include <stdio.h>

unsigned ROMmap_npages = 8;

unsigned long ROM2NESaddr(unsigned long addr)
{
    unsigned page = addr >> 16;
    unsigned offs = addr & 0x3FFF;
    if(page == ROMmap_npages-1) return offs | 0xC000;
    return (page << 16) | offs | 0x8000;
}

unsigned long NES2ROMaddr(unsigned long addr)
{
    switch(addr / 0x4000)
    {
        case 0: case 1: break; // 0..7
        case 3: // C..F
        {
            unsigned page = ROMmap_npages-1;
            unsigned offs = addr & 0x3FFF;
            return page * 0x4000 + offs;
        }
        case 2:  // 8..B
        default: // 10...
            unsigned page = addr >> 16;
            unsigned offs = addr & 0x3FFF;
            return page * 0x4000 + offs;
    }
    return addr;
}
/*
unsigned long NES2ROMaddr(unsigned long addr)
{
    unsigned long ret = NES2ROMaddr_(addr);
    printf("NES %X -> ROM %X\n", addr, ret);
    return ret;
}
*/