static void Wily2Ascii(Screen& s)
{
    GenericAsciiMaker(s,
// Sky
-1,'.', 0x01,2,
// Shadow
-1,',', 0x00,0,
// Walls
-1,'#', 0x48,1, 0x49,1, 0x4A,1,
        0x50,1, 0x51,1, 0x52,1, // block type 1 (middle piece repeatable)
-1,'&', 0x0A,1, 0x09,1, 0x0A,1,
        0x10,1, 0x11,1, 0x12,1, // pseudo block (looks same as block 1)
-1,'#', 0x4E,1, // platform
-1,'#', 0x61,2, // / edge (bottomside)
-1,'#', 0x60,2, // \ edge (bottomside)
-1,'#', 0x62,2, // / edge (topside)
// Decorations
-1,' ', 0x17,3, 0x16,3, // inside bg, inside shadow
-1,' ', 0x23,2, 0x24,2, // window (preferably 2x2)
// Spike
-1,'^', 0xC4,2,
// Ladder
-1,'|', 0x85,0,
// Boss bg (random colours)
-1,'X', 0x25,3, 0x26,3, 0x27,3,
-2);
}

#define Wily2Char  DummyChar

static Level Wily2 =
{
	7, // level number
	"Wily2",

	// screens:
	{
		{
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"#############..."   "                "
		"######.........."   "                "
		"#####..........."   "                "
		"####............"   "                "
		"###............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		, 0 // monster graphics index
		,LevelBegin| Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   " y             y"
		"................"   "     y          "
		"................"   "                "
		"................"   "                "
		"######...####..."   "    y           "
		"................"   "                "
		"................"   "            e   "
		"............##.."   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		, 0 // monster graphics index
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "               y"
		"................"   "   y            "
		"................"   "                "
		"................"   "                "
		"######...####..."   "  y             "
		"................"   "                "
		"................"   "                "
		"............##.."   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		, 0 // monster graphics index
		,Right},
		{
		".......^########"   "                "
		"......^#########"   "                "
		".....^##########"   "                "
		"....^###########"   "                "
		"...^############"   "                "
		"..^#############"   "   y            "
		"..##############"   "                "
		"..##############"   "                "
		"....,,,,,,,,,,##"   "  y             "
		"....,,,,,,,,,,##"   "                "
		"....,,,,,,,,,,##"   "                "
		"####,,,,,,,,,,##"   "            pp  "
		"....####&&######"   "                "
		"....####&&######"   "                "
		"....####&&######"   "                "
		"....####&&######"   "                "
		, 0 // monster graphics index
		,Down},
		{
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##?&############"   "                "
		"##&&############"   "                "
		"##?&############"   "                "
		"##&&############"   "                "
		, 1 // monster graphics index
		,Down},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"######...####..."   "                "
		"................"   "                "
		"................"   "            e   "
		"............##.."   "             v  "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		, 2 // monster graphics index
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"######...####..."   "                "
		"................"   "                "
		"................"   "                "
		"............##.."   "             v  "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		, 2 // monster graphics index
		,Right},
		{
		".......^########"   "                "
		"......^#########"   "                "
		".....^##########"   "                "
		"....^###########"   "                "
		"...^############"   "                "
		"..^#############"   "                "
		"..##############"   "                "
		"..##############"   "                "
		"....,,,,,,,,,,##"   "                "
		"....,,,,,,,,,,##"   "                "
		"....,,,,,,,,,,##"   "                "
		"####,,,,,,,,,,##"   "            pp  "
		"....######?&####"   "                "
		"....######&&####"   "                "
		"....######?&####"   "                "
		"....######&&####"   "                "
		, 2 // monster graphics index
		,Down},
		{
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##?&############"   "                "
		"##&&############"   "                "
		"##?&############"   "                "
		"##&&############"   "                "
		, 3 // monster graphics index
		,Down},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"######...####..."   "                "
		"................"   "                "
		"................"   "            p   "
		"............##.."   "                "
		"................"   "                "
		"................"   "                "
		"................"   "       B       B"
		"................"   "                "
		, 2 // monster graphics index
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"######...####..."   "                "
		"................"   "                "
		"................"   "            p   "
		"............##.."   "                "
		"................"   "                "
		"................"   "                "
		"................"   "      B       B "
		"................"   "                "
		, 2 // monster graphics index
		,Right},
		{
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..............##"   "                "
		"..............##"   "                "
		"#############|##"   "                "
		"......#######|##"   "                "
		".......######|##"   "                "
		"........#####|##"   "                "
		".........#### ##"   "                "
		"..........### ##"   "                "
		, 2 // monster graphics index
		,Down},
		{
		"..........### ##"   "                "
		"..........### ##"   "                "
		"..........##  ##"   "  U             "
		"..#.......##  ##"   "                "
		"..........## ###"   "                "
		"..........    ##"   "          c     "
		"..........    ##"   "                "
		"......####### ##"   "                "
		"........####  ##"   "            c   "
		".........###  ##"   "                "
		"..........## ###"   "                "
		"..........##  ##"   "             h  "
		"..........##  ##"   "                "
		"..........###|##"   "                "
		"..........### ##"   "                "
		"..........### ##"   "                "
		, 0 // monster graphics index
		,Down| RestartPointA},
		{
		"..........### ##"   "                "
		"..........### ##"   "                "
		"..........    ##"   "                "
		"..........    ##"   "                "
		"..........    ##"   "                "
		"^^..^^^^^^    ##"   "                "
		"############ ###"   "                "
		"........####  ##"   "             h  "
		".........###  ##"   "             h  "
		"..........### ##"   "                "
		"..........##  ##"   "                "
		"..........##  ##"   "             c  "
		"..........##|###"   "                "
		"..........##|###"   "                "
		"..........## ###"   "                "
		"..........## ###"   "                "
		, 0 // monster graphics index
		,Down},
		{
		"..........## ###"   "                "
		"..........## ###"   "                "
		"..........## ###"   "                "
		"..........## ###"   "                "
		".........###  ##"   "                "
		"........####  ##"   "                "
		".......#####  ##"   "                "
		"......######  ##"   "                "
		"......##      ##"   "                "
		"......##      ##"   "                "
		"......##      ##"   "             h  "
		"......##      ##"   "        h       "
		"......##      ##"   "             h  "
		"......##|#######"   "                "
		"......## #######"   "                "
		"......## #######"   "                "
		, 0 // monster graphics index
		,Down},
		{
		"......## #######"   "                "
		"......## #######"   "                "
		"......##      ##"   "                "
		"......##      ##"   "                "
		".....|##      ##"   "             <  "
		".....|##      ##"   "                "
		".....|##      ##"   "             {  "
		".....|##      ##"   "  P             "
		"..#..|##      ##"   "             <  "
		".....|##      ##"   "                "
		".....|##      ##"   "             {  "
		".....|        ##"   "                "
		".....|        ##"   "                "
		".....########|##"   "                "
		".....######## ##"   "                "
		".....######## ##"   "                "
		, 0 // monster graphics index
		,Down},
		{
		".....######## ##"   "                "
		".....######## ##"   "                "
		".....###      ##"   "                "
		"....^###      ##"   "        h       "
		"...^####      ##"   "             h  "
		"..^##### #######"   "                "
		".^####        ##"   "                "
		"^#####        ##"   "                "
		"####          ##"   "    >           "
		"####          ##"   "             h  "
		"############# ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##|#############"   "                "
		"## #############"   "                "
		"## #############"   "                "
		, 0 // monster graphics index
		,Down| RestartPointB},
		{
		"##,#############"   "                "
		"##,#############"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 4 // monster graphics index
		,End},
	},

	// palette
	{
		15, 43, 24,  7, 
		15, 43, 24, 22, 
		15, 43, 24, 28, 
		15, 24,  9,  7, 

		15, 44, 17, 15, 
		15, 32, 56, 15, 
		15, 48, 42, 15, 
		15, 48, 17, 15, 

		15, 43, 24,  7, 
		15, 43, 24, 22, 
		15, 43, 24, 28, 
		15, 48, 16, 16, 
	},

	// after doors palette
	{
/* Not used in Wily stages */
	},

	// actives
	{
	},

	// enemies
	{
	},

	// level gfx (id, count) (max 16); id is block*4+bank
	{
		{ 0x40, 8 }, { 0x6E, 1 }, { 0x92, 3 }, { 0x72, 1 }, 
		{ 0xE2, 1 }, { 0xD8, 1 }, { 0x5E, 1 }, { 0xC0, 2 }, 
		{ 0x43, 4 }, { 0xD8, 2 }, { 0x73, 2 }, { 0x63, 6 }, 
	},

	// monster gfx tables (max 11) (5 tiles, 2*3bytepalette)
	{
		{ { 0x6E, 0x92, 0x96, 0x62, 0x72, }, { 48,42,15, 48,17,15,} },
		{ { 0x60, 0x64, 0x68, 0x6C, 0x46, }, { 48,21,15, 48,38,15,} },
		{ { 0xBA, 0x7E, 0xAE, 0x7A, 0x7E, }, { 48,21,15, 48,21,15,} },
		{ { 0xB0, 0xB4, 0xB8, 0xBC, 0x52, }, { 39,21,15, 48,38,15,} },
		{ { 0x63, 0x46, 0x4A, 0x42, 0x52, }, { 32,56,15, 15,56,24,} },
	},

	0x20, // Arrival input

	Wily2Ascii, Wily2Char
};
